<template>
  <v-card>
    <v-card-title>{{`${user.name} ${user.lastName}`}}</v-card-title>
    <v-divider></v-divider>

    <v-list class="transparent">
      <v-list-item
        v-for="category in categories"
        :key="category.name"
        :href="self[category.instance][category.linkValue]" target="_blank"
      >
        <v-list-item-subtitle>{{ category.name }}:</v-list-item-subtitle>
        <v-list-item-title>
          {{ self[category.instance][category.value] }}
        </v-list-item-title>
        <v-list-item-avatar>
          <v-img :src="self[category.instance][category.imageValue]"></v-img>
        </v-list-item-avatar>
      </v-list-item>
      <v-list-item @click="additionalInfo=!additionalInfo">
        <v-list-item-subtitle class="text-center">{{ additionalInfo ? "Скрыть подробную информацию" : "Показать подробную информацию" }}</v-list-item-subtitle>
      </v-list-item>
      <div v-if="additionalInfo">
        <div
          v-for="category in additionalCategories"
          :key="category.name"
        >
          <v-list-item>
            <v-list-item-title>{{ category.name }}</v-list-item-title>
          </v-list-item>
          <v-divider></v-divider>
          <v-list-item
            v-for="categoryItem in category.items"
            :key="categoryItem.name"
            :href="self[categoryItem.instance][categoryItem.linkValue]" target="_blank"
          >
            <v-list-item-subtitle>{{ categoryItem.name }}:</v-list-item-subtitle>
            <v-list-item-title>{{ self[categoryItem.instance][categoryItem.value] }}</v-list-item-title>
            <v-list-item-avatar>
              <v-img :src="self[categoryItem.instance][categoryItem.imageValue]"></v-img>
            </v-list-item-avatar>
          </v-list-item>
        </div>
      </div>
    </v-list>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue';
import { Component, Prop, Watch } from 'vue-property-decorator';
import { getModule } from 'vuex-module-decorators';
import OrganizationModule from '@/store/modules/organizations';
import { IUser, IOrganizationIfno, IUniversityInfo } from '@/interfaces.ts';

@Component
export default class ProficeInfoCard extends Vue {
  @Prop() public user!: IUser;
  @Prop() public organization!: IOrganizationIfno;
  @Prop() public group!: IUniversityInfo;

  public self = this;

  private additionalInfo = false;
  private categories = [
    {
      name: 'Университет',
      value: 'name',
      instance: 'group',
      linkValue: 'universityURL',
    },
    {
      name: 'Место работы',
      value: 'name',
      instance: 'organization',
      linkValue: 'organizationURL',
    },
  ];
    private additionalCategories = [
      {
        name: 'Образование',
        items: [
          {
            name: 'Университет',
            value: 'name',
            instance: 'group',
            linkValue: 'siteURL',
            imageValue: 'labelURL',

          },
          {
            name: 'Кафедра',
            value: 'cathedralName',
            instance: 'group',
          },
          {
            name: 'Направление',
            value: 'speciality',
            instance: 'group',
          },
          {
            name: 'Группа',
            value: 'groupName',
            instance: 'group',
          },
          {
            name: 'Курс',
            value: 'course',
            instance: 'group',
          },
        ],
      },
      {
        name: 'Карьера',
        items: [
          {
            name: 'Место работы',
            value: 'name',
            instance: 'organization',
            imageValue: 'labelURL',
            linkValue: 'organizationURL',
          },
          {
            name: 'Описание',
            value: 'description',
            instance: 'organization',
          },
          {
            name: 'Должность',
            value: 'position',
            instance: 'organization',
          },
        ],
      },
  ];

  protected openURL(url: string) {
    window.open(url);
  }
}
</script>
